## soqt 1.6.0~e8310f

=== debian/changelog ===
soqt (1.6.0~e8310f-4) unstable; urgency=medium

  * Team upload.
  * [5b6250e] Apply cme fix dpkg
  * [35d7aca] Set Standards-Version: 4.1.3
  * [d6d6dac] Remove testsuite-field
  * [990bbc4] Remove old Conflicts/Replaces-fields
  * [eb50247] Set compat-level 10
  * [88f0cfa] Remove autotools_dev from d/rules
  * [1904f74] Remove myself from uploaders
  * [0dee212] Use salsa-VCS

 -- Anton Gladky <gladk@debian.org>  Fri, 29 Dec 2017 17:50:48 +0100

soqt (1.6.0~e8310f-3) unstable; urgency=medium

  * [1affbbe] Fix autopkgtest. Do not start X-application.
  * [8e4a9f1] Apply cme fix dpkg.

 -- Anton Gladky <gladk@debian.org>  Thu, 26 May 2016 20:31:10 +0200

soqt (1.6.0~e8310f-2) unstable; urgency=medium

  * [7f03626] Set canonical VCS-field.
  * [a91d64c] Fix license name in d/copyright.
  * [5824c2f] Set Standards-Version: 3.9.6. No changes.
  * [5345733] Add libsoqt4-dev.prerm to remove old alternatives.
              (Closes: #730091).
  * [7c87f55] Add autopkgtests.

 -- Anton Gladky <gladk@debian.org>  Wed, 15 Oct 2014 21:12:12 +0200

soqt (1.6.0~e8310f-1.1) unstable; urgency=low

  * NMU
  * Use autotools-dev to update config.{sub,guess} and
    {libtool,aclocal}.m4. Closes: #744660, #765257

 -- Steve McIntyre <93sam@debian.org>  Wed, 15 Oct 2014 00:38:32 +0100

soqt (1.6.0~e8310f-1) unstable; urgency=low

  * [7158525] Move maintainership into debian-science-team.
  * [8596233] Remove some obsolete files.
  * [1dd5f9a] Imported Upstream version 1.6.0~e8310f
  * [6b50de8] Update homepage.
  * [2efcc04] Use dh 9. Simplify debian/rules.
  * [adae349] Add TODO.
  * [8b79572] Add files from SoGui as a patch. Need for build.
  * [729840d] Set Standards-Version 3.9.4. No change.
  * [0f30b6a] Update copyright file (BSD-license), use DEP-5.
  * [67be221] Use wrap-and-sort.

 -- Anton Gladky <gladk@debian.org>  Tue, 17 Sep 2013 21:13:53 +0200

soqt (1.5.0-2.1) unstable; urgency=low

  * Non-maintainer upload.
  * Migrate from coin60 to coin80.
  * Update debian/watch (Bart Martens <bartm@debian.org>).

 -- Anton Gladky <gladk@debian.org>  Tue, 28 May 2013 22:17:52 +0200
