=== debian/control ===
Source: soqt
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Section: graphics
Priority: optional
Build-Depends: debhelper (>= 10),
               doxygen,
               autotools-dev,
               libcoin80-dev,
               libqt4-dev,
               libqt4-opengl-dev,
               qt4-dev-tools
Standards-Version: 4.1.3
Vcs-Browser: https://salsa.debian.org/science-team/soqt
Vcs-Git: https://salsa.debian.org/science-team/soqt.git
Homepage: https://bitbucket.org/Coin3D/soqt

Package: libsoqt-dev-common
Architecture: any
Section: libdevel
Depends: ${misc:Depends}
Description: Qt GUI component toolkit for Inventor - common development files
 SoQt is a Qt GUI component toolkit library for Coin, based on the
 API of the InventorXt GUI component toolkit.  SoQt is also compatible
 with OpenInventor of SGI and TGS.
 .
 This package provides headers, manpages, and other development
 environment files common to both the Qt3 and Qt4 versions of
 SoQt.

Package: libsoqt4-20
Architecture: any
Section: libs
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Qt4 GUI component toolkit for Inventor - runtime
 SoQt is a Qt GUI component toolkit library for Coin, based on the
 API of the InventorXt GUI component toolkit.  SoQt is also compatible
 with OpenInventor of SGI and TGS.
 .
 This library is linked against Qt version 4.

Package: libsoqt4-dev
Architecture: any
Section: libdevel
Depends: libcoin80-dev,
         libqt4-dev,
         libqt4-opengl-dev,
         libsoqt-dev-common (= ${binary:Version}),
         libsoqt4-20 (= ${binary:Version}),
         qt4-dev-tools,
         ${misc:Depends}
Provides: libsoqt-dev
Description: Qt4 GUI component toolkit for Inventor - development
 SoQt is a Qt GUI component toolkit library for Coin, based on the
 API of the InventorXt GUI component toolkit.  SoQt is also compatible
 with OpenInventor of SGI and TGS.
 .
 SoQt provides a class-hierarchy of viewer classes that ranges from a
 simple render canvas (the SoQtRenderArea), providing only the basic
 synchronization and device input conversion routines between Qt and
 Coin, up to 3 different full-featured viewer classes
 (SoQtExaminerViewer, SoQtPlaneViewer and SoQtFlyViewer) with input
 device handling logic and user interfaces to let the application
 programmer do Rapid Application Development.
 .
 This library is linked against Qt version 4.
