=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@ --without autoreconf


override_dh_auto_configure:
	dh_auto_configure -- --with-coin --enable-man

override_dh_auto_install:
	dh_auto_install
	dh_link -plibsoqt4-20 usr/lib/$(DEB_HOST_MULTIARCH)/libSoQt.so.20.6.0 usr/lib/$(DEB_HOST_MULTIARCH)/libSoQt4.so.20.6.0
	dh_link -plibsoqt4-20 usr/lib/$(DEB_HOST_MULTIARCH)/libSoQt.so.20 usr/lib/$(DEB_HOST_MULTIARCH)/libSoQt4.so.20
	dh_link -plibsoqt4-dev usr/lib/$(DEB_HOST_MULTIARCH)/libSoQt.so usr/lib/$(DEB_HOST_MULTIARCH)/libSoQt4.so
	dh_link -plibsoqt4-dev usr/share/Coin/conf/soqt-default.cfg usr/share/Coin/conf/soqt-qt4.cfg
	rm -rf debian/tmp/usr/share/man/man3/_*.*
