=== debian/changelog ===
soqt (1.6.0~ea5cd76+ds1-1ubuntu2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:10:57 +0100

soqt (1.6.0~ea5cd76+ds1-1ubuntu1) disco; urgency=medium

  * Update autopkgtests to use qmake instead of soqt-config.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Tue, 12 Feb 2019 19:22:36 +0300

soqt (1.6.0~ea5cd76+ds1-1) unstable; urgency=medium

  * Version from experimental to unstable. Transition of coin3.
  * Package built against Qt5. Closes: #875186

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Wed, 19 Dec 2018 23:39:11 +0100

soqt (1.6.0~ea5cd76+ds1-1~exp1) experimental; urgency=medium

  * New upstream version. git 20181028
  * Drop unnecessary file. Only one version
  * Migration to Qt5. Rename packages and simplified them
  * Removing trailing spaces
  * Update patches
  * Fix Qt4 to Qt5 strings
  * Added myself as Uploader
  * Setting 520, SoQt, as SONAME. Added a patch.
  * Bump Standards. No changes

 -- Leopold Palomo-Avellaneda <leo@alaxarxa.net>  Mon, 29 Oct 2018 11:56:17 +0100
