=== debian/tests/control ===
Tests: test01 test02 test03 test04 test05
Depends: libsoqt520-dev, qt5-qmake, build-essential
