=== debian/watch ===
version=3
opts=dversionmangle=s/\.ds// \
https://bitbucket.org/Coin3D/coin/downloads/SoQt-(\d.*)\.(?:tgz|tbz2|txz|tar\.(?:gz|bz2|xz))
# Bart Martens <bartm@debian.org>  Sat, 05 Jan 2013 11:43:01 +0000
